/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIMAGENTSREADER_H
#define ALLSIMAGENTSREADER_H

#include "world.h"
#include "simnetwork.h"
#include "agent.h"
#include "trip.h"
#include "global.h"
#include <string>
#include <vector>

using namespace std;

namespace allsim 
{
namespace microsim
{

/**
@author David Charypar
*/


class AgentsReader
{
public:
	static void loadAgentsFromXML(char const *filename, World *theWorld);
	static void loadAgentsFromBinaryFile(char const *filename, World *theWorld);

private:
	AgentsReader();
	~AgentsReader();
	static void startHandler(void *data, const char *el, const char **attr);
	static void endHandler(void *data, const char *el);
	static void characterDataHandler(void *userData, const char *s, int len);
	static void agentHandlerStart(const char **attr);
	static void agentHandlerEnd();
	static void planHandlerStart(const char **attr);
	static void planHandlerEnd();
	static void actHandlerStart(const char **attr);
	static void actHandlerEnd();
	static void legHandlerStart(const char **attr);
	static void legHandlerEnd();
	static void routeHandlerStart(const char **attr);
	static void routeHandlerEnd();

	static unsigned depth;
	static char Buff[BUFFSIZE];

	static Agent *currentAgent;
	static World *theWorld;
	
	// this is needed to store the route stored in pcdata....
	static bool currentPlanSelected;
	static bool isInsideRoute;
	static char routeBuffer[BUFFSIZE];
	static unsigned int routeBufferCounter;
	static unsigned int currentActivityStartLinkId;
	static Trip *currentTrip;
	

};

}
}

#endif
