/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIMCONFIGCONFIGREADER_H
#define ALLSIMCONFIGCONFIGREADER_H

#include <string>
#include "global.h"

using namespace std;

namespace allsim 
{
namespace config
{

/**
	@author David Charypar <david.charypar@switzerland.org>
*/
class ConfigReader
{
public:
	static void loadConfigFromXML(char const *filename);
private:
	ConfigReader();
	~ConfigReader();

	static void startHandler(void *data, const char *element, const char **attributes);
	static void endHandler(void *data, const char *element);
	static void moduleHandlerStart(const char **attributes);
	static void moduleHandlerEnd();
	static void paramHandlerStart(const char **attrributes);
	static void paramHandlerEnd();

	static char Buff[BUFFSIZE];

	static string moduleName, paramName, paramValue;
};

}
}

#endif
