/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIMSERIALIZER_H
#define ALLSIMSERIALIZER_H

#include <vector>
using std::vector;

namespace allsim {
namespace microsim {


/**
@author David Charypar
*/
class Serializer
{
private:
	Serializer();
	~Serializer();

public:
	static void setVector(vector<char> *theVector);

	template<class T>
	static void serializeToVector(T const variable)
	{
		char const *buf = reinterpret_cast<char const*>(&variable);
		for(unsigned i = 0; i < sizeof(variable); ++i)
			theVector->push_back(buf[i]);
	}

	template<class T>
	static vector<char>::const_iterator unserializeFromVectorIterator(T &variable, vector<char>::const_iterator iter)
	{
		char *buf = reinterpret_cast<char*>(&variable);
		for(unsigned i = 0; i < sizeof(variable); ++i)
		{
//			buf[i] = *iter++;
			buf[i] = *iter;
			iter++;
		}
		return iter;
	}


private:
	static vector<char> *theVector;

};

}
}

#endif
