/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIM_MICROSIM_SIMNETWORK_H
#define ALLSIM_MICROSIM_SIMNETWORK_H


//#include "node.h"
//#include "link.h"
//#include "simnode.h"
#include "world.h"
#include "agent.h"
#include "network.h"
#include <map>
#include <vector>
#include <set>

using namespace std;

namespace allsim {
namespace microsim {

using namespace tools;

class SimNode;

class SimNetwork :public tools::Network
{
public:
	explicit SimNetwork(Network const &baseNet);
	virtual ~SimNetwork();
	virtual void partitionNetwork(unsigned numBisectionSteps);
	virtual void createRoadsForWorld(World &theWorld);
	virtual void printNodeLoadsToStream(ostream &outFile);
	virtual void loadLoadsFromStream(istream &inFile);
	virtual void printLinkProcAssignmentToStream(ostream &outStream);
	

private:
	virtual void assignNodesToProc(unsigned numBisectionStepsWidth, unsigned numHeight);
	virtual void bisectNodes(vector<SimNode*> &nodesVector, unsigned minId, unsigned remainingBisectionSteps);
	virtual int getLoadBasedCutPoint(vector<SimNode*>::const_iterator iStart,
	                                 vector<SimNode*>::const_iterator iEnd);
	static void setProcIdOfSimNode(SimNode *sn, unsigned newProcId);
	static bool compareXOfTwoNodes(Node const *n1, Node const *n2);
	static bool compareYOfTwoNodes(Node const *n1, Node const *n2);

	map<int, int> nodeLoads;
};

}
}

#endif
