/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIMNODE_H
#define ALLSIMNODE_H

#include <vector>
#include <map>
#include "node.h"

using namespace std;

namespace allsim 
{
namespace microsim
{

/**
@author David Charypar
*/
class SimNode : public tools::Node
{
public:
	SimNode(unsigned id, double xCoord, double yCoord);
	SimNode(Node const &node);
	virtual ~SimNode();

	unsigned getProcId() const;
	void setProcId(unsigned newProcId);
	unsigned getTotalTrafficVolume() const;
	void increaseInVolume();
	void increaseOutVolume();
	

protected:
	unsigned procId;
	unsigned totalInVolume, totalOutVolume;

};

}
}
#endif
