/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "event.h"

namespace allsim {

namespace tools {

Event::Event(double time, unsigned agentId, unsigned legNr, 
             unsigned linkId, unsigned fromNodeId, unsigned type)
:time(time),
agentId(agentId),
legNr(legNr),
linkId(linkId),
fromNodeId(fromNodeId),
type(type)
{
}


Event::~Event()
{
}

double Event::getTime() const
{
	return time;
}

unsigned Event::getAgentId() const
{
	return agentId;
}

unsigned Event::getLegNr() const
{
	return legNr;
}

unsigned Event::getLinkId() const
{
	return linkId;
}

unsigned Event::getFromNodeId() const
{
	return fromNodeId;
}

unsigned Event::getType() const
{
	return type;
}

std::ostream &operator<<(std::ostream &theStream, Event const &event)
{
	theStream << "[Event@" << event.time << ", aId=" << event.agentId;
	theStream << ", legNr=" << event.legNr;
	theStream << ", linkId=" << event.linkId;
	theStream << ", fromNodeId=" << event.fromNodeId;
	theStream << ", type=" << event.type << "]";
	return theStream;
}




}

}
