/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIM_TOOLSEVENTSSTREAMREADER_H
#define ALLSIM_TOOLSEVENTSSTREAMREADER_H

#include "event.h"
#include <fstream>

namespace allsim 
{

namespace tools 
{

using namespace std;
/**
@author David Charypar
*/
class EventsStreamReader
{
public:
	EventsStreamReader();
	~EventsStreamReader();

	void openFile(char const * eventsFilename);
	bool hasNextEvent();
	Event getNextEvent();
private:
	void readNextEventFromFile();
	
	ifstream eventsFile;
	Event currentEvent;
	unsigned int eventsCounter, nextOutputCount;
	bool hasValidEvent;


};

}

}

#endif
