/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hashclass.h"
#include <limits>



namespace allsim 
{
namespace tools 
{

using namespace std;

HashClass::HashClass()
{
}

HashClass::~HashClass()
{
}

unsigned int HashClass::getHashValue(unsigned int data)
{
	unsigned int hash;
	unsigned int tmp;
	
	hash  = data;// && 0x0000ffff;
	tmp   = ((data && 0xffff0000) >> 5) ^ hash;
	hash  = (hash << 16) ^ tmp;
	hash  += hash >> 11;

	hash ^= hash << 3;
	hash += hash >> 5;
	hash ^= hash << 4;
	hash += hash >> 17;
	hash ^= hash << 25;
	hash += hash >> 6;

	return hash;
}

double HashClass::getHashedValueAsDouble(unsigned int data)
{
	return static_cast<double>(getHashValue(data)) / static_cast<double>(numeric_limits<unsigned int>::max());
}




}

}
