/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIMTOOLSLINK_H
#define ALLSIMTOOLSLINK_H

#include <queue>

using namespace std;

namespace allsim {
namespace tools {

class Node;

class Link
{
public:
	Link(unsigned id, Node *fromNode, Node *toNode, double length, 
	     double flowCapacity, double freeSpeed, unsigned numLanes);
	virtual ~Link();

	virtual void setFromNode(Node *newFromNode);
	virtual void setToNode(Node *newToNode);

	virtual unsigned int getId() const;
	virtual Node *getFromNode() const;
	virtual Node *getToNode() const;
	virtual double getLength() const;
	virtual double getFlowCapacity() const;
	virtual double getSpace() const;
	virtual double getFreeSpeed() const;
	virtual int getNumLanes() const;
	virtual double getFreeSpeedTravelTime() const; 
	virtual double getMinimalGap() const;
	

protected:
	unsigned const id;
	Node *fromNode, *toNode;
	double length;
	double flowCapacity;
	double freeSpeed;
	unsigned numLanes;
};
}
}

#endif
