/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIMTOOLSNETWORKREADER_H
#define ALLSIMTOOLSNETWORKREADER_H

#include <string>
#include "toolsglobal.h"

using namespace std;

namespace allsim 
{
namespace tools
{


class Network;

/**
@author David Charypar
*/
class NetworkReader
{
public:
	static Network *loadNetworkFromXML(char const *filename);

private:
	NetworkReader();
	~NetworkReader();

	static void startHandler(void *data, const char *el, const char **attr);
	static void endHandler(void *data, const char *el);
	static void characterDataHandler(void *userData, const char *s, int len);
	static void networkHandlerStart(const char **attr);
	static void networkHandlerEnd();
	static void nodeHandlerStart(const char **attr);
	static void nodeHandlerEnd();
	static void linksHandlerStart(const char **attr);
	static void linksHandlerEnd();
	static void linkHandlerStart(const char **attr);
	static void linkHandlerEnd();
	



	static unsigned depth;
	static char Buff[BUFFSIZE];
	static Network *currentNetwork;
	static double capPeriod;


	

};

//	double convertTimeStringToTime(string timeString);

}
}

#endif
