/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIMTOOLSNODE_H
#define ALLSIMTOOLSNODE_H

#include "link.h"
#include <vector>
#include <map>

using namespace std;

namespace allsim 
{
namespace tools
{


/**
@author David Charypar
*/
class Node{
public:
	/** constructor for normal usage (e.g. during network read in) */
	Node(unsigned id, double xCoord, double yCoord);
	/** explict copy constructor
	    only copies the properties but not the connections to link objects */
	explicit Node(Node const &source);
	virtual ~Node();

	void addOutgoingLink(Link *outgoingLink);
	void addIncomingLink(Link *incomingLink);
	Link *getLinkToNeighborNode(Node *neighborNode);
	Link *getLinkFromNeighborNode(Node *neighborNode);
	unsigned getId() const;
	double getXCoord() const;
	double getYCoord() const;
	
	unsigned getNumIncomingLinks() const;
	unsigned getNumOutgoingLinks() const;
	
	

protected:
	unsigned id;
	double xCoord, yCoord;
	vector<Link*> outgoingLinks, incomingLinks;
};

}
}

#endif
