/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "stopwatch.h"

namespace allsim {
namespace tools {

///	Takes the system time between a start and an end time
///
///	@author David Charypar <charypar@ivt.baug.ethz.ch>

StopWatch::StopWatch()
{
}

StopWatch::~StopWatch()
{
}

void StopWatch::start()
{
	startTime = time(NULL);
}

void StopWatch::end()
{
	endTime = time(NULL);
}

double StopWatch::getMeasuredTime() const
{
	return difftime(endTime, startTime);
}

char const *StopWatch::getStartTime()
{
	return ctime(&startTime);
}

char const *StopWatch::getEndTime()
{
	return ctime(&endTime);
}


}

}
