/***************************************************************************
 *   Copyright (C) 2005-2007 by David Charypar   *
 *   david.charypar@switzerland.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALLSIMGLOBAL_H
#define ALLSIMGLOBAL_H

#include<limits>
#include<fstream>

using namespace std;

namespace allsim
{
	unsigned const BUFFSIZE = 64*1024;
	bool const DEBUG = false;
	bool const ALL = true;
	bool const SQUEEZE = false;
	bool const ENTRY_ONLY = true;
	bool const WRITE_MATSIM_EVENTS = true;
	unsigned const AGENTID1 = 717544;
//	unsigned const AGENTID1 = numeric_limits<unsigned>::max()-1;
//	unsigned const AGENTID2 = 81144; //375110; //6428013;
	unsigned const AGENTID2 = numeric_limits<unsigned>::max()-1;
//	unsigned const LINKID1 = 2086; // 3470; //2143;
	unsigned const LINKID1 = numeric_limits<unsigned>::max()-1;
//	unsigned const LINKID2 = 2094; // 2481;
	unsigned const LINKID2 = numeric_limits<unsigned>::max()-1;
//	double const SYNC_INTERVAL = 100.0;
//	double const SQUEEZE_TIME = 10.0;
	double const SYNC_OFFSET = 1e-6;
	unsigned const DISP_PREC = 18;

	// declaration of global variables:

	namespace tools
	{
		class Network;
	}

	extern tools::Network theNetwork;

	double convertTimeStringToTime(string timeString);
}

#endif
